<p align="center">
<img src="https://raw.githubusercontent.com/coldbox-modules/cbdebugger/development/resources/assets/images/CBDebugger300.png">
</p>

<p align="center">
	<img src="https://forgebox.io/api/v1/entry/cbdebugger/badges/version" alt="Latest Stable Version" />
	<a href="https://www.apache.org/licenses/LICENSE-2.0.html">
		<img src="https://img.shields.io/badge/license-Apache--2-green" alt="License">
	</a>
</p>

# Welcome To The ColdBox Debugger Module

The ColdBox Debugger module is a light-weight performance monitor and profiling tool for ColdBox applications.  It can generate a nice debugging panel on every rendered page or a dedicated visualizer to make your ColdBox application development nicer, funner and greater! Yes, funner is a word!

<p align="center">
	<img src="https://raw.githubusercontent.com/coldbox-modules/cbdebugger/development/test-harness/includes/images/debugger-visualizer.png">
</p>

<p align="center">
Debugger Request Visualizer
</p>

<br>

<p align="center">
	<img src="https://raw.githubusercontent.com/coldbox-modules/cbdebugger/development/test-harness/includes/images/debugger-collapsed.png">
</p>

<p align="center">
Request Tracker Collapsed
</p>

## Capabilities

The ColdBox debugger is a light-weigth performance monitor and profiler for your ColdBox applications.  It tracks your requests, whether Ajax, traditional or REST, it's environment, execution and much more.  Here is a listing of some of the capabilities you get with the ColdBox Debugger:

- Track all incoming requests to your applications
- Track exceptions and execution environment
- Track incoming HTTP requests, parameters, body, and much more
- Track final request collections
- Track Hibernate and cborm queries, criteria queries, and session stats
- Track qb and quick queries, entities, and stats
- Tap into LogBox via our Tracer messages and discover logging on a per-request basis
- Profile execution and results of ANY model object
- Profile execution of ANY ColdBox interception point
- Custom Timer helpers for adding timing methods and annotations anywhere in your code
- Profile your production or development apps with ease
- Track ColdBox modules and lifecycles
- Track Hyper HTTP/S calls
- Track Adobe ColdFusion Queries (ColdFusion 2018+)
- Track Lucee Queries

## License

Apache License, Version 2.0.

## Important Links

- Docs: https://cbdebugger.ortusbooks.com/
- Source: https://github.com/coldbox-modules/cbdebugger
- ForgeBox: https://www.forgebox.io/view/cbdebugger
- Community: https://community.ortussolutions.com/c/box-modules/cbdebugger/38
- Issues: https://ortussolutions.atlassian.net/browse/CBDEBUGGER
- [Changelog](changelog.md)

## System Requirements

- Lucee 5+
- ColdFusion 2018+
- ColdBox 6+

## Optional Requirements

https://cbdebugger.ortusbooks.com/essentials/installation#optional-requirements

# Instructions

https://cbdebugger.ortusbooks.com/essentials/installation

## Settings

The debugger is highly configurable and we have tons of settings to assist you in your development adventures and also in your performance tuning. Please note that the more collectors you activate, the **slower** your application can become.  By default we have pre-selected defaults which add neglible performance to your applications.

You can find how to configure the debugger here:
https://cbdebugger.ortusbooks.com/essentials/configuration

## Usage

https://cbdebugger.ortusbooks.com/essentials/request-tracker

********************************************************************************
Copyright Since 2005 ColdBox Framework by Luis Majano and Ortus Solutions, Corp
www.coldbox.org | www.luismajano.com | www.ortussolutions.com
********************************************************************************

# HONOR GOES TO GOD ABOVE ALL

Because of His grace, this project exists. If you don't like this, then don't read it, its not for you.

>"Therefore being justified by faith, we have peace with God through our Lord Jesus Christ:
By whom also we have access by faith into this grace wherein we stand, and rejoice in hope of the glory of God.
And not only so, but we glory in tribulations also: knowing that tribulation worketh patience;
And patience, experience; and experience, hope:
And hope maketh not ashamed; because the love of God is shed abroad in our hearts by the
Holy Ghost which is given unto us. ." Romans 5:5

## THE DAILY BREAD

 > "I am the way, and the truth, and the life; no one comes to the Father, but by me (JESUS)" Jn 14:1-12
